VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "15"
   ClientHeight    =   3900
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   4560
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3900
   ScaleWidth      =   4560
   StartUpPosition =   2  'CenterScreen
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

DefLng A-Z
Dim emptyID, i, j, s As String
Const size = 1000, gap = 48
Dim cells(1 To 16)

Private Sub Form_Load()
  AutoRedraw = True: Font.size = 18: BackColor = vbBlue: ForeColor = vbCyan
  Width = size * 4 + gap * 3: Height = size * 4 + gap * 3 + 300
  For i = 1 To 16: cells(i) = i: Next
  Randomize: Shuffle
End Sub
Private Sub Form_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
  Dim id: id = Int(Y / size) * 4 + Int(X / size) + 1
  i = Abs(id - emptyID): If (i <> 4) And (i <> 1) Then Exit Sub
  Swap id, emptyID
  PrintCell emptyID: PrintCell id
  emptyID = id
  If Win Then MsgBox "Win!", , "15": Shuffle
End Sub

Private Sub Shuffle()
  For i = 16 To 1 Step -1
    j = Int(Rnd * i) + 1
    Swap j, i
  Next
  If Not Solveable Then
     If emptyID > 2 Then Swap 1, 2 Else Swap 3, 4
  End If
  For i = 1 To 16: PrintCell i: Next
End Sub

Private Sub Swap(a, b)
   Dim n: n = cells(a)
   cells(a) = cells(b): cells(b) = n
End Sub

Private Function Solveable() As Boolean
  emptyID = 16
  For i = 1 To 15
    For j = i + 1 To 16
      If cells(j) < cells(i) Then Solveable = Not Solveable
    Next
    If cells(i) = 16 Then emptyID = i
  Next
  If (emptyID \ 4 Mod 2) = 0 Then Solveable = Not Solveable
End Function

Private Sub PrintCell(n)
  Dim X, Y, s As String
  X = (n - 1 And 3) * size: Y = ((n - 1) \ 4) * size
  Line (X + gap, Y + gap)-(X + size - gap, Y + size - gap), &HA0A0A0, BF
  s = cells(n): If s = 16 Then Exit Sub
  CurrentX = X + (size - TextWidth(s)) / 2: CurrentY = Y + (size - TextHeight(s)) / 2
  Print s
End Sub

Private Function Win() As Boolean
  For i = 1 To 16
    If cells(i) <> i Then Exit Function
  Next
  Win = True
End Function

